/** CUSTOM SCRIPTS **/
jQuery(document).ready(function($){ 
    // Save settings
    $('#wpbe_elements_form').on('submit', function(e){
        e.preventDefault();
        $.ajaxSetup({ cache: false });
        const settings = {};

        // Serialize all input data
        $("#wpbe_elements_form input:checkbox").each(function(){ if(this.name){ settings[this.name] = this.checked; }});
        $("#wpbe_elements_form input:text").each(function(){ if(this.name){ settings[this.name] = this.value; }});
        $("#wpbe_elements_form textarea").each(function(){ if(this.name){ settings[this.name] = this.value; }});

        // Find and loop through all TinyMCE editors and serialize all data
        $('#wpbe_elements_form').find('.wp-editor-area').each(function(){
            const id = $(this).attr('id');
            const editor = tinyMCE.get(id);

            if(editor && $('#wp-' + id + '-wrap').hasClass('tmce-active')){
                const editorId = editor.id;
                const editorContent = editor.getContent({format : 'html'}).replace(/\\/g,"").replace('<p>','').replace('</p>','');

                if(editorId){
                    settings[editorId] = editorContent;
                }
            }
        });

        // Create the data that will be sent to database
        const data = { 
            'action': 'wpbe_save_settings',
            'data': settings
        };
        
        // Make an call to AJAX to insert data in database
        $.post(ajaxurl, data, function(response){
            $('#wpbe_popup').css({'display' : 'flex'});
        });
    });

    // Make Tabs clickable
    $('.wpbe-tabs-wrapper a').click(function(e){ 
        e.preventDefault();
        $('.wpbe-tabs-wrapper a').removeClass('active');
        $(this).addClass('active');
        $('.div-tab').hide();
        $('#' + $(this).attr("data-id")).show(); 
    }); 

    // Close the popup window
    $('#wpbe_button').on('click', function(e){
        $('#wpbe_popup').css({'display' : 'none'});
    });

    // Display the info box
    $('#info').on('click', function(e){
        $('#wpbe-info-notice').slideToggle();
    });
});